VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2595
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3975
   LinkTopic       =   "Form1"
   ScaleHeight     =   2595
   ScaleWidth      =   3975
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'http://msdn.microsoft.com/library/default.asp?URL=/library/psdk/winui/menus_9dwl.htm

Private Const MAX_PATH = 260

Private Const MF_INSERT = &H0
Private Const MF_CHANGE = &H80
Private Const MF_APPEND = &H100
Private Const MF_DELETE = &H200
Private Const MF_REMOVE = &H1000
Private Const MF_BYCOMMAND = &H0
Private Const MF_BYPOSITION = &H400
Private Const MF_SEPARATOR = &H800
Private Const MF_ENABLED = &H0
Private Const MF_GRAYED = &H1
Private Const MF_DISABLED = &H2
Private Const MF_UNCHECKED = &H0
Private Const MF_CHECKED = &H8
Private Const MF_USECHECKBITMAPS = &H200
Private Const MF_STRING = &H0
Private Const MF_BITMAP = &H4
Private Const MF_OWNERDRAW = &H100
Private Const MF_POPUP = &H10
Private Const MF_MENUBARBREAK = &H20
Private Const MF_MENUBREAK = &H40
Private Const MF_UNHILITE = &H0
Private Const MF_HILITE = &H80
Private Const MF_DEFAULT = &H1000
Private Const MF_SYSMENU = &H2000
Private Const MF_HELP = &H4000
Private Const MF_RIGHTJUSTIFY = &H4000
Private Const MF_MOUSESELECT = &H8000

Private Declare Function GetMenu Lib "USER32" (ByVal hWnd As Long) As Long
Private Declare Function GetSubMenu Lib "USER32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetMenuString Lib "USER32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal uIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal uFlag As Long) As Long
Private Declare Function GetMenuItemCount Lib "USER32" (ByVal hMenu As Long) As Long
Private Declare Function GetMenuItemID Lib "USER32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetMenuState Lib "USER32" (ByVal hMenu As Long, ByVal uId As Long, ByVal uFlags As Long) As Long ' MF_CHECKED, MF_DISABLED, MF_GRAYED, MF_HILITE, MF_MENUBARBREAK, MF_MENUBREAK, MF_OWNERDRAW, MF_POPUP, MF_SEPARATOR
Private Declare Function ModifyMenu Lib "USER32" Alias "ModifyMenuA" (ByVal hMnu As Long, ByVal uPosition As Long, ByVal uFlags As Long, ByVal uIDNewItem As Long, ByRef lpNewItem As Any) As Long

Private Declare Function FindWindow Lib "USER32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetWindowText Lib "USER32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal nMaxCount As Long) As Long

Private hWindow   As Long
Private hMenu     As Long
Private hRootMenu As Long

Private Sub Form_Load()
  
  Dim TheCaption As String
  Dim TheID      As Long
  Dim TheState   As Long
  Dim TheSub     As Long
  Dim TheHandle  As Long
  Dim MenuCount  As Long
  Dim MyCounter  As Long
  Dim NewCaption As String
  
  hWindow = FindWindow(vbNullString, "Untitled - Notepad")
  If hWindow = 0 Then GoTo ExitOut
  
  TheCaption = String(MAX_PATH, Chr(0))
  GetWindowText hWindow, TheCaption, MAX_PATH
  TheCaption = Left(TheCaption, InStr(TheCaption, Chr(0)) - 1)
  
  hRootMenu = GetMenu(hWindow)
  If hRootMenu = 0 Then GoTo ExitOut
  
  MenuCount = GetMenuItemCount(hRootMenu)
  If MenuCount = 0 Then GoTo ExitOut
  
  For MyCounter = 0 To MenuCount - 1
    TheCaption = String(MAX_PATH, Chr(0))
    GetMenuString hRootMenu, MyCounter, TheCaption, MAX_PATH + 1, MF_BYPOSITION
    TheCaption = Left(TheCaption, InStr(TheCaption, Chr(0)) - 1)
    Debug.Print "[ " & TheCaption & " ]"
    
    TheHandle = GetSubMenu(hRootMenu, MyCounter)
    TheState = GetMenuState(hRootMenu, MyCounter, MF_BYPOSITION)
    TheID = GetMenuItemID(hRootMenu, MyCounter)
    TheSub = GetMenuItemCount(TheHandle)
    If TheSub > 0 Then
      GetSubMenus TheHandle, TheSub
    End If
    Debug.Print " "
    
  Next
  
ExitOut:
  
  Unload Me
  
End Sub

Private Function GetSubMenus(ByVal hMenu As Long, ByVal SubMenuCount As Long) As Boolean
  
  Dim TheCaption As String
  Dim TheID      As Long
  Dim TheState   As Long
  Dim TheSub     As Long
  Dim TheHandle  As Long
  Dim MenuCount  As Long
  Dim MyCounter  As Long
  
  For MyCounter = 0 To SubMenuCount - 1
    TheCaption = String(MAX_PATH, Chr(0))
    GetMenuString hMenu, MyCounter, TheCaption, MAX_PATH + 1, MF_BYPOSITION
    TheCaption = Left(TheCaption, InStr(TheCaption, Chr(0)) - 1)
    
    TheHandle = GetSubMenu(hMenu, MyCounter)
    TheState = GetMenuState(hMenu, MyCounter, MF_BYPOSITION)
    TheID = GetMenuItemID(hMenu, MyCounter)
    TheSub = GetMenuItemCount(TheHandle)
    
    If (TheState And MF_SEPARATOR) = MF_SEPARATOR Then
      TheCaption = "----------------------"
    Else
      If (TheState And MF_CHECKED) = MF_CHECKED Then
        TheCaption = TheCaption & " *CHECKED*"
      ElseIf ((TheState And MF_DISABLED) = MF_DISABLED) Or _
             ((TheState And MF_GRAYED) = MF_GRAYED) Then
        TheCaption = TheCaption & " *DISABLED*"
      End If
    End If
    Debug.Print TheCaption
    
  Next
  
End Function
